### Build 17
- Diversified heal rate for military buildings - the bigger, the quicker.
- Improved and remodelled a lot of the buildings' animations.
- Improved and remodelled a lot of the bobs' animations.
- Improved and remodelled a lot of terrain graphics.
- Improved dedicated server functionality:
    * now runable as daemon and thus via init.d script on servers
    * added possibility to write server statistics to html files
    * added functionality to save the game on the server via chat command.
    * added functionality to set up a password for the server.
    * added functionality to set a custom message of the day (motd).
    * improved client side handling / setting up of dedicated servers.
- Improved a lot of icons and button appearence.
- Improved statistics window.
- Improved the Widelands code to use less resources.
- Improved OpenGL rendering which is now active by default.
- Improved (slightly) the computer player through use of the new
  dismantle feature.
- Replaced the old libggz based metaserver support with our own ggz
  independed solution, which brings some new features as well:
    * The metaserver is now checking whether a game is connectable
      if it is not, it sends an error message to the client to
      inform it.
    * System messages on the metaserver like global announcements
      motd changes or Error-Messages are now imported to running
      games and shown there as well.
    * The metaserver does now check whether a client is still online
      regulary and disconnects it, if it isn't.
    * If the client gets disconnected from the metaserver during a
      running game, the client is able to reconnect silently.
    * Games can now have more than 7 connected clients
    * The Version of Widelands used in a game is now shown as hover text
      in the game list. If a game is connectable, but uses a different
      version, a "?" icon is shown to visualise that difference.
- Added a new piece of music to Widelands
- Added new states and animations for unoccupied buildings and empty mines,
  to better indicate the current state of a building.
- Made road textures world dependend and improved the style of the roads
  for each world.
- Added basic seafaring functionality:
    * Ports, ships and shipyards are already working as they should.
    * Loading of settlers 2 seafaring maps is supported
    * (Scouting and colonization *NOT* yet implemented)
  yet implemented.
- Added port buildspace tool to the editor.
- Added a new feature to list maps in the map selection menu in categories
- Added a new feature "dismantle building" allowing to recycle some of
  the resource used to build the building.
- Added a new win condition "endless game (no fog)" with completely
  visible map from the beginning on.
- Added two multiplayer scenarios.
- Added a big seafaring map, playable as scenario.
- Added feature to play as a random tribe or against a random tribe or
  random AI.
- Added click animation for the mouse pointer
- Added automatic release of second carrier (oxen, donkey, horse), if
  the road traffic is not that strong anymore, that a second carrier
  would be needed.
- Added a new undo/redo feature to the Editor.

- Fixed a bug that disallowed to connect to different servers (via
  metaserver) without prior restart of Widelands.
- (Re)Fixed bug #536149: miner/master miner mixed up after enhancing
  to deep mine.
- Fixed bug #565406: focus for save window
- Fixed bug #570055: Open house window on doubleclick even when minimized
- Fixed bug #590528: add more details to a replay
- Fixed bug #590631: All workers die, when warehouse/hq is destroyed
- Fixed bug #594686: Roads not rendered correctly in opengl mode on
                     some systems
- Fixed bug #601400: Request::get_base_required_time:WARNING nr = 1 but
                     count is 1, which is not allowed according to the
                     comment for this function
- Fixed bug #649037: Many menus are not repainted in OpenGL mode
- Fixed bug #657266: Unoccupied helmsmithy animation contains a person
- Fixed bug #671485: Aged barbarian ware icons
- Fixed bug #672085: New stock menu layout too high for small resolutions
- Fixed bug #672098: The priority buttons can be deactivated
- Fixed bug #674848: The fight against red player in barbarian tutorial 3
                     can be won in just one fight
- Fixed bug #683716: Better handling of "no ressources"
- Fixed bug #691928: Message icon is not updated in some cases when
                     receiving focus
- Fixed bug #695035: Adjusted hotspots of buildings to fit into their space
- Fixed bug #702011: Messages in multiplayer are translated by host
                     before they are sent to client
- Fixed bug #722196: OpenGL terrain renderer does not dither between
                     adjacent fields
- Fixed bug #722793: Ducks on land on Three Warriors
- Fixed bug #722796: Minimap not shaded by terrain height in OpenGL
- Fixed bug #723112: The name is not shown for resource coal in the
                     resource dialog in the editor
- Fixed bug #726699: Make the wares priority buttons in production sites
                     more intuitive
- Fixed bug #734409: campaign texts about enhancing metalworks
- Fixed bug #731474: Barbarian buildings looking strange when covered
                     by fog of war
- Fixed bug #738888: Two sentences in game tips are only partly translatable
- Fixed bug #741142: Empire Tut 2 - missing event when barbarians
                     are detected
- Fixed bug #768828: Fixed the random height tool window in the editor
- Fixed bug #768854: Messages for win condition "Territorial Lord" is not
                     translated, even though translations exist
- Fixed bug #771962: Alphabetically sorted ware help in translations
- Fixed bug #772003: Bakingtray use the peel icon
- Fixed bug #775132: build-16 Failed to initialize SDL, no valid video driver
- Fixed bug #779967: Text alignment on "Host a new game"
- Fixed bug #786243: Add extra column to stock windows, if size would be to
                     big for the current screen resolution
- Fixed bug #787365: Constr.Site & Prod.Site: Dim House Picture In
                     The Background
- Fixed bug #787508: Remove use of barbarian stronghold
- Fixed bug #791421: Editor: Map Options Editbox Keyboard Input
- Fixed bug #795457: focus in chat window
- Fixed bug #799201: New tab icon for workers list
- Fixed bug #805089: Check client in chat commands, when first mentioned.
- Fixed bug #808008: Delete outdated data when updating Widelands on Windows
- Fixed bug #817078: "Watch window" should centre more suitably
- Fixed bug #818784: display player names in status messages when playing
                     collectors
- Fixed bug #842960: Original building site graphic is visible during
                     construction sequence
- Fixed bug #852434: no game tips on loading screen as host
- Fixed bug #853217: start multiplayer game with all slots closed
- Fixed bug #855975: Atlantean bakery jumping up, when start working
- Fixed bug #859079: Warning about files (pngs) not found when
                     starting a new game
- Fixed bug #859081: Dialog briefly shown when clicking in the fog of war
- Fixed bug #865995: Allied soldiers fight when they meet on the battlefield
- Fixed bug #870129: highlighted message can not be marked
- Fixed bug #871401: WaresQueue stock level configuration is ignored
                     when work fails in Productionsites
- Fixed bug #877710: [windows] window title shows "not responding"
                     when loading a map
- Fixed bug #884966: Not able to prioritize top row (pita bread) in
                     battle arena
- Fixed bug #886493: Default AI is set to none
- Fixed bug #886572: After a while, increasing game speed makes the game
                     lag even at lower speeds
- Fixed bug #887093: Make OpenGL the standard renderer
- Fixed bug #902765: Show buttons in the bottom toolbar in the same
                     order, also for spectators
- Fixed bug #902823: Show "increase/decrease capacity" buttons only
                     in "soldiers" tab
- Fixed bug #912486: Maximum FPS button overlaps language list in options
                     on higher resolutions
- Fixed bug #914462: possible bug in void BulldozeConfirm::think()
- Fixed bug #924140: assertion failed if you press "up/down" button in
                     an empty message window
- Fixed bug #924768: Rework barbarian barrier's statistics
- Fixed bug #927110: font color not adapted to map color



### Build 16
- Many new graphics, new sounds.
- Added a dedicated server function for terminal use.
- Improved and refactored font handler.
- Removed barbarian Stronghold from list of buildable military sites as
  it did not have a real purpose.
- Added a help button + window function (e.g. to explain the multi player
  menu).
- Play a fanfare when a military site gets occupied and another fanfare
  when the player is under attack
- Reworked the multi player launch game menu - now different clients can
  control the same in game player together (share the kingdom) and other
  starting positions can be "shared" in as second (third, fourth, ...)
  starting position of a player.
- Add a new Atlantean campaign map.
- Add rudimentary support for ships (you can build them, but they are not yet
  useful)
- Add support for multiplayer scenarios. No scenario is shipped yet though.
- Added column for the maximal number of players to the map selection menu.
- Reordered wares and workers in logical groups (e.g. food production, ...).
  Also fix the Economy Preferences Menu to be similar to the new Warehouse
  windows.
- Barbarian lumberjacks now need a felling_axe which is produce in the metal
  workshop. The axe is now only produced in the war mill and the axe factory.
  This delays barbarian soldier production in the early game, giving the other
  tribes more time to equalize their military production. (bug #667286)
- Give Empire +1 basket so that two vineyards can be build right away to fully
  saturate the first marble mine.
- Buttons that represent a toggable state are now really toggable buttons in
  the user interface.
- Changed the way compressed files are generated (maps, savegames) and read.
  Now it is possible to rename maps and savegames but it is not possible
  to load maps from version after this change with versions before this change
- Added a dotted frame border to the mini map.
- Work area preview is now on by default.
- New maps: Desert Tournament, Swamp Monks.
- Improved and added many new animations for workers
- Improved and added fighting animations for soldiers
- Implemented teamview for allied players
- Implemented shared kingdom mode, where two or more players control the same
  player.
- Added two new maps.
- Added possibility to create and play multiplayer scenarios.
- Do not show building statistic informations of opposing players anymore
- Gave foresters more intelligence - now they do not remove young trees to
  replant another anymore and plant the trees that suit the terrain the best.
- Added host commands like /announce, /kick, ... (type /help in chat window
  to get a list of available commands).
- Improved defaultAI's behaviour.
- Added "real" work animations for builders and play "idle" animation, if
  the builder has nothing to do.
- Made Empire baracks more useful.
- Added player number user interface and automatic start position placement in
  random generated maps.
- Improved the heigth generation algorithm of the map autogenerator to produce
  more playable maps.
- Added notification messages for players, when military sites are occupied.
- Added teams (alliances can now be defined before start)
- Now the builder does nomore cause the finished building to see its vision
  range.
- Many improvements of the graphic rendering engine
- Implemented "stop storing", "out source", "prefare ware" settings for
  warehouses.
- Improved military site's and training site's user interface.
- Improved health bar and level icons for soldiers.
- Improved all exisiting campaigns to use lua.
- Added an interactive "start from no knowledge" tutorial.
- Added new music tracks.
- Added winning conditions (endless game, autocrat, collectors, land lord,
  wood gnome).
- Added basic opengl rendering support.
- Added many new and improved exisiting translations.
- Removed unused medic code.
- Reduced healing rate of soldiers.
- New keyboard shortcuts for the message window: N, G, Delete.
- New keyboard shortcuts for quick navigation: comma, period, and (Ctrl+)0-9.
- Experience required by workers per level is no longer random.
- Made the empire barracks a little more useful.
- Improved stock menu: Use tabs and add warehouse-only tabs.
- Changed the boss key from F10 to Ctrl+F10.
- Story Message Boxes are nomore closed by right clicking.
- Added command line option to tell Widelands where to search for translations.
- Improved some of the exisiting maps.
- Improved the "user friendly" compile script and moved it to compile.sh
- Fixed the translation system - users should now be able to select any
  compiled and installed translation of Widelands.
- Removed scons and replaced it with cmake.
- Fixed two potential security issues (internet gaming)
- Fixed bug #729772: Selection of Widelands.ttf via options menu
- Fixed bug #687342: No longer complain when a master miner is transferred to
  a mine to fill a junior position.
- Fixed bug #612348: Soldiers always move out of buildings to battle
- Fixed bug #670980: Cmd_EnemyFlagAction::Write handles disappeared flag
- Fixed bug #697375: Handle state.coords == Null() correctly in soldier attack code
- Fixed bug #691909: Compatibility with old savegames with barbarian battlearena
- Fixed bug #722789: Always flush animations before loading
- Fixed bug #724169: Military site window no longer changes size erratically
- Fixed bug #708328: infinite loop(s) in building_statistics_menu.cc
- Fixed bug #720338: Options show wrong resulution as selected if no
  ~/.widelands/conf exists
- Fixed bug #536149: miner/master miner mixed up after enhancing to deep mine
- Fixed bug #580073: Objectives menu update
- Fixed bug #695735: Scrollbar damaged in multiline textboxes in (unique)
  windows in FS menu
- Fixed bug #659884: Problem with network savegame loading under windows
- Fixed bug #683082: copy constructor should take const argument
- Fixed bug #669085: Wood Lance (Empire ware) is practically invisible
  in ware encyclopedia
- Fixed bug #680207: Economy settings missing ores
- Fixed bug #583985 and #573863: Scout did not work as it was supposed to.
- Fixed bug #618449: [fetchfromflag] - building dissappeared.
- Fixed bug #537392: Computerplayer does not adhere to currently allowed
  buildings.
- Fixed bug #547090: Make barbarian weaving mill not buildable.
- Fixed bug #577891: Make atlantean small tower less strong.
- Fixed bug #615891: Commandline parameters homedir and datadir parsing.
- Fixed bug #554290: GGZ game hosting on windows was not working before.
- Fixed bug #533245: Buildings statistics were not calculated correctly.
- Fixed some filesystem bugs.
- Fixed desync bug #590458 and allowed syncstream writing without replay writing
- Fixed replay bug when using recursive destroy (pressing Ctrl while destroying)
- Fixed remaining "tabard cycling" problem and cleanup related to recent economy
  changes.
- Fixed bug #577247: When constructionsite finishes, set builder's location to
  the new building.
- Fixed bug #580377: Member function defined in .cc file should not be declared
  inline.
- Fix bug with nosound option.
- Fixed language list, to only show the found languages - that way it should be
  clearer to the user, in case when translations were not compiled.
- Fixed directory browsing in Map save dialog of the editor.
- Fixed bug #568371: Stray numbers in player table in GGZ menu.
- Fixed bug #536373: Race between "transfer" and "cancel" signals.
- Fixed bug #569737: Failed assert when trying to overwrite save
- Fixed bug #568373: Removed flag display in the building statistic menu
- Fixed many other bugs.

### Build 15
- Removed registering functionality for metaserver. This is to be compatible
  with future changes to the metaserver.
- Small text tweaks and translation updates.
- New graphics for some buildings and menu pics.
- Fix for Multiline Editboxes that could lead the Editor to crash.
- Scout runs a little longer to make it more useful.
- Fixed descyns happening when a scout left his house in network games.
- Healthy soldiers defend while injured ones heal at MilitarySite (bzr:5084)
- Fixed bug when PM is send to the player hosting a network game.
- Fishbreeder no longer complains about no fish found.
- Conquered buildings now appear in statistics.
- Improvements in the build_and_run.sh script and cmake building in general.
- Sound & Music system is now thread safe.
- Win 32 bug fix: Mine symbols were not visible in VC++ builds.
- Fix defending soldiers making invisible and freezing battles.
- Support for building with Visual Studio
- New graphics for some buildings
- Added second carrier type for busy roads (donkeys, oxen, horses)
- Changed localization structure so that we can translate from launchpad.net
- Cmake is now a supported build system
- Lua support (preliminary)
- Fix bug that when a worker program had a createitem command where the
  parameter was not the name of a ware type in the tribe, the game would fail
  an assertion when the command was executed. Now throw an exception when the
  command is parsed. (svn:r4847)
- Implement a the "scout" command in worker programs. Add a worker type "scout"
  to each tribe. Such a worker type typically lives in a small house/hut
  (productionsite). The productionsite's work program typically consists of a
  sleep period, consumption of some food, and sending the worker out to explore
  nodes that have never been seen before or not seen recently. (svn:r4840,
  svn:r4841, svn:r4843, svn:r4844, svn:r4845)
- In the chat, doubleclicking a username will add @username so that the text
  that is written after will be sent as a personal message to that user.
  (svn:r4832)
- Implemented double size zoom mode for minimap (svn:r4820, svn:r4821)
- Added login/register menu for games via metaserver (svn:r4818, svn:r4819)
- Added a small scenario part to "The Green Plateau" map (svn:r4808, svn:r4810)
- Improve map select menu - now the "play as scenario" checkbox is only usable,
  if the selected map is playable as scenario (= if a file "trigger" exists).
  Further it shows a special icon for scenario maps for a direct indication.
  (svn:r4807)
- Added new event "seeall" allowing to switch see all mode of a player to
  on/off. (svn:r4804, svn:r4878)
- In productionsite programs: Generalize failure handling method to result
  handling method. Depending on the result of the called program, the calling
  program can now return failed, completed or skipped. It can also chose to
  continue execution or repeat the call. (svn:r4781)
- Added new loading screens for Desert, Greenland and Winterland. (svn:r4778,
  svn:r4816)
- Improved Battle code
    * Added support for soldier combat animations (svn:r4772)
    * Let soldiers retreat, when they are injured. Let the player configure in
      the game how injured they have to be to retreat. Make it configurable in
      scenarios and initializations to what extent a player should be able to
      configure this feature during the game. (svn:r4796, svn:r4812)
    * New attack user interface (svn:r4802, svn:r4803, svn:r4813)
- Fix bug that if a user sent a private chat message to himself, the nethost
  delivered it to him twice. (svn:r4764)
- Added a new map 'Atoll' (svn:r4755)
- Add the production program return condition type "site has" that takes a
  group (just like the consume command). Now it is possible to have a statement
  "return=failed unless site has bread,fish,meat:4". (svn:r4750)
- When parsing a consume group, check that the count is not so large that the
  group can not be fulfilled by the site. For example if a site has "[inputs]"
  "smoked_fish=6", "smoked_meat=6" and a program has a consume command with the
  group "smoked_fish,smoked_meat:13" it will give an error message (previously
  it was just accepted silently). (svn:r4750)
- Fix bug that prevented parsing of a negation condition in a production
  program return statement. (svn:r4748)
- Change some productionsites to produce even if the product is not needed, if
  none of the inputs nor the site's capacity are needed either, so that wares
  of a more refined type are available when they are needed in the future.
  (svn:r4746, svn:r4748, svn:r4751)
- Fix broken logic of productionsite program's return command's when-condition.
  (svn:r4745)
- Show in the statistics string why a building is not working. (svn:r4744)
- When a productionsite program has been skipped, do not start it again until
  at least 10 seconds have passed, to avoid slowing down the simulation. The
  drawback is that it may take longer time until the productionsite discovers
  that it should produce something (for example because the amount of a ware
  type dropped below the target quantity). (svn:r4743)
- Fix bug that 40 characters was read from a file into a buffer that was used
  as a 0-terminated string (the building statistics string). This worked as
  long as the file provided the 0-terminator. Now make sure that the buffer is
  0-terminated regardless of what the file contains. Previously the whole
  buffer was written (including the garbage after the terminator). Now only
  write the real content. (svn:r4742)
- Fix the editor's trigger time option menu. (svn:r4740)
- Fix the map Sun of fire so that there is no longer possible to walk (attack)
  along the coast between players 4 and 5.
- Improvements in replay handling to save diskspace (svn:r4719, svn:r4720)
    * Only write syncstreams in multiplayer games
    * Delete old (definable) replay files and syncstreams at startup
- Replace the event type that allows or forbids a building type for a player
  with 2 separate event types (for allow and forbid respectively). They can
  handle multiple building types in the same event and the configuration dialog
  is more complete, with icons for the building types. (svn:r4717)
- Implement event types to set the frontier/flag style of a player (can also be
  used in initializations). Also implement configuration dialogs for those
  event types. (svn:r4709, svn:r4715).
- Change the code so victorious soldiers conquer an opposing militarysite,
  instead of destroying it. (svn:r4706 - svn:r4711, svn:r4724, svn:r4727,
  svn:r4731, svn:r4732, svn:r4822, svn:r4839)
- Fix bug that caused undenfined behaviour, particularly segmentations faults in
  64-bit optimized builds. (svn:r4702)
- Improve player's message queue: (svn:r4698)
    * Add only important and not doubled messages.
    * Play a sound, if a new message arrives.
    * Play special sounds at special events (e.g. "You are under attack")
- Fix bug that a savegame, with a flag on a node that was not interior to the
  flag's owner, could be loaded. (svn:r4695)
- Fix bug that a scenario game could be started from a map, where a player did
  not have a starting position, causing a failed assertion when trying to
  center the view on the player's home location. (svn:r4694)
- Fix out-of-bounds array access bug in network game lobby code. (svn:r4676)
- Fix bug that panel_snap_distance and border_snap_distance were mixed up when
  initializing the spinboxes in the options menu. (svn:r4665)
- Fix crash when trying to use the editor to add an event, of type
  conquer_area, with the same name as an existing event. (svn:r4655)
- Fix a bug in ids of autogenerated maps and add automatic resource, immovable
  and critter placement to the automatic map generation feature. (svn:r4651,
  svn:r4679)
- Fix bug that a savegame, with flags on neighbouring map nodes, could be
  loaded, leading to errors later on (for example when trying to build a 1-step
  road between them). (svn:r4621)
- Fix bug that a savegame, where a flag was placed on one map node but later
  was given the coordinates of another map node, could be loaded, leading to
  errors later on. (svn:r4620)
- Added more stones to the Elven Forests map. (svn:r4612)
- Improved the selection of which warehouse a produced ware should be
  transported to. (svn:r4609)
- Add new music. (svn:r4602, svn:r4611)
- Change the reporting of an error that is found in game data (savegame,
  command log, world/tribe definitions) whenever such game data is read (for
  example when a replay or new or saved game is started or a new or saved map
  is loaded in the editor). Do not include source code filename:linenumber
  information (just explain what is wrong with the game data that the user
  tried to load). Return to where the user tried to load the game data
  (menu/shell). (svn:r4600)
- Fix bug that sometimes a warehouse did not provide a carrier to fulfill a
  request when it should. (svn:r4599)
- Change bob movement by eliminating a 10 ms pause before starting to move
  along an edge. The game logic could fail and throw an exception if a bob was
  moving along a road and the road was split during those 10 ms. Unfortunately
  this fix breaks each old savegame with a bob that happens to be in this
  state. (svn:r4597)
- Fix memory leaks. (svn:r4567, svn:r4671, svn:r4672, svn:r4673, svn:r4674,
  svn:r4675, svn:r4677, svn:r4681, svn:r4682, svn:r4756)
- Fix bug that when the editor's map options window was opened and the map's
  description was shorter than a certain length (different for different
  locales), the program would crash when a letter was typed in the description
  multilineeditbox. (svn:r4563)

### Build 14
- Fix bug that the Firegames map had no water. (svn:r4533)
- New tree and stone graphics for the Blackland world. (svn:r4525, svn:r4526,
  svn:r4527, svn:r4528, svn:r4529)
- Fix bug that the Atlantean and Empire Hunter's Houses were not shown as meat
  producers in the ware encyclopedia. (svn:r4521)
- Fix bug that in the new event/trigger dialogs, the Ok button was enabled even
  when an event/trigger type was selected, for which no options window is
  implemented. Nothing happened when the button was pressed. Now the button is
  disabled and a note is shown, explaining that an event/trigger of this type
  must be created by editing the text files (with a regular text editor instead
  of the Widelands editor). (svn:r4512)
- Fix bug that when a ware was waiting at a flag, and the next flag or building
  that the ware was waiting to be taken to was removed, anyting could happen
  (because of a dangling pointer). (svn:r4508)
- Fix usability problem that accidentally double-clicking on a road could
  remove it. (Previously, when clicking on a node that had a road, but a flag
  could not be placed there, the mouse cursor would be placed over the button
  to remove the road, in the dialog that was opened. Now place the mouse cursor
  over the tab icon instead in that case.) (svn:r4490)
- When entering automatic roadbuilding mode after creation of a non-connected
  flag, move the mouse cursor to the flag, to offer optimal conditions to
  either start building a road, in any direction from that flag, or directly
  click on the flag to stop building the road. (svn:r4489)
- Give more progress information during editor startup by showing a message for
  each tribe that is being loaded. (svn:r4488)
- When a progress indicator has been shown during animation loading, remove the
  message "Loading animations: 99%" afterwards, so that the user is not mislead
  to believe that animation loading is still going on, when in fact something
  else is taking time. (svn:r4486)
- Some "plastic surgeries" on editor menus.
  (svn:r4481, svn:r4482, svn:r4483, svn:r4484, svn:r4485)
- Fix bug that in the editor's event menu, the buttons to change and delete an
  event chain where enabled even when no event chain was selected in the list.
  This caused a crash when any of the 2 buttons was clicked. (svn:r4480)
- Make sure that every soldier battle property that is loaded from a savegame
  and is not compatible with the soldier's type's definition is adjusted to the
  nearest valid value. This makes changes to a soldier type's battle properties
  affect preexisting savegames when they are loaded with the changed game data.
  (svn:r4479)
- Fix bug that a soldier without hitpoints could be loaded from a savegame.
  (svn:r4478)
- Fix memory access error caused by a value read from a savegame being used as
  an array index without being checked. (svn:r4477)
- Fix null pointer dereference that could be caused by an invalid savegame.
  (svn:r4475)
- Fix bug that if a savegame contained a soldier with
  max hitpoints < current hitpoints, it was not detected as an error.
  (svn:r4474)
- Fix bug that when loading (from a savegame) a bob (such as a worker or wild
  animal) that was walking along an edge between 2 neighbouring nodes, it was
  not checked that the start time was before the end time. (Both times are
  stored in savegames.) (svn:r4470)
- Fix bug that when a military-/trainingsite was loaded from a savegame, it was
  not checked whether the configured capacity was within the range of allowed
  values, as defined in the site's type. Do not reject the savegame if the
  value is outside the range, since the definition may have changed and the
  user wants to load the game anyway. Just warn and adjust the variable to the
  nearest valid value. (svn:r4468, svn:r4469)
- Fix bug that the parsing of a worker type would allow
  max_experience < min_experience. (svn:r4467)
- Fix wrong calculation of the amount of experience that a worker needs to
  change its type. The value is chosen randomly in an interval, from
  min_experience to max_experience, specified in the soldier's type's
  definition. But the calculation had an off-by-one error that caused the value
  to never become max_experience, and worse, crash with a division by 0 when
  min_experience = max_experience. (svn:r4466)
- Fix bug that the game loading code would accept a soldier with
  max_attack < min_attack. (svn:r4465)
- Fix bug that the parsing of a soldier type would allow
  max_attack < min_attack. (svn:r4464)
- Fix wrong calculation of a soldier's attack value during battle. The value is
  chosen randomly in an interval, from min_attack to max_attack. But the
  calculation had an off-by-two error that caused the value to never become
  max_attack or max_attack - 1, and worse, crash with a division by 0 when
  min_attack + 1 = max_attack. (svn:r4463)
- Fix wrong calculation of a soldier's maximum hitpoints during its creation.
  The value is chosen randomly in an interval, from min_hp to max_hp, specified
  in the soldier's type's definition. But the calculation had an off-by-one
  error that caused the value to never become max_hp, and worse, crash with a
  division by 0 when min_hp = max_hp. (svn:r4462)
- Fix bug that a corrupt savegame could cause gametime to go backwards (a
  !GameLogicCommand could have a duetime in the past without being detected as
  corrupt during load). (svn:r4460)
- Fix invalid memory access bug (causisng random behaviour) when a section file
  inside a zip-archive was missing a newline at the end. (svn:r4443)
- Fix bug that trigger building could count large buildings sevaral times
  because they occupy several nodes on the map. (svn:r4441)
- Added Italian translation (svn:r4435, svn:r4436)
- Fix drawing of text with non-latin1 characters. (svn:r4421)
- When a soldier steps outside his territory during attack, he searches for
  militarysites with defenders. Previously he chose them from any other player.
  Now only choose defenders from the player whose territory the soldier steps
  on. (svn:r4410)
- Exit with an error when incompatible command line parameters are given,
  instead of ignoring it. (svn:r4406)
- Allow starting a replay from the command line by giving the --replay=FILENAME
  parameter. If just --replay is given, the program goes directly to the replay
  file selection menu. (svn:r4405)
- Fix display of multiline editoboxes when the text has more than one
  consecutive linebreak. (svn:r4395)
- Fix navigation in multiline editboxes. When the last line was empty and the
  text cursor was at the end of the line above, it was not possible to move the
  cursor to the last line with the down arrow key. (svn:r4394)
- Fix bug that the text cursor was not visible when at the beginning of a line
  (in a single- or multiline editbox). (svn:r4393).
- Give spectators (see-only) access to the building and economy configuration
  windows. Same for players with see-all right (debug builds). (svn:r4380,
  svn:r4399)
- When a soldier can not move to its opponent during an attack, do not give up
  and quit the program. Instead, let the soldier desert without punishment.
  Notify the 2 involved players by adding a message to their message queues and
  pausing the game. Also pause and give a message when a worker can not return
  home to his building and therefore becomes a fugitive. (svn:r4378)
- Fix bug that the in-/decrease buttons in the editor's noise height options
  menu were not repeating. (svn:r4459)
- Fix bug that the buttons in the editor's change resources options menu were
  not properly disabled. (svn:r4458)
- Fix bug that the traingingsite window soldier buttons (drop selected soldier,
  decrease soldier capacity and increase capacity) were not properly disabled
  and that the latter 2 were not repeating. (svn:r4373)
- Fix bug that the building window background graphic was not drawn with
  correct playercolour. (svn:r4369)
- Fix bug that buildings that were behind fog were not drawn with correct
  playercolour. (svn:r4367)
- Fix bug in buildcaps calculation. Sometimes it was possible to build a large
  building at location A and then build a large building at location B. But if
  a large building was built at location B first, it was no longer possible to
  build a large building at location A. (svn:r4366)
- Fix bug that the content of the interactive player data packet in a savegame
  was used without being checked properly, which could lead to a segmentation
  fault. (svn:r4353)
- Fix bug in the editor that it was possible to remove a player even though
  it was referenced by someting (such as an event or trigger). (svn:r4339)
- Fix bug that for a worker type, an experience value was read and used even
  though the worker type could not become some other worker type. (svn:r4328)
- Make the config file format somewhat stricter. Do not allow // comments and
  require a section header to be closed with a ']'. (svn:r4285, svn:r4298)
- No longer look for bmp an gif images when searching for animation frames.
  This should make animation loading a little faster. (svn:r4278)
- Added and improved some buildings and workers animations (different svn rev.)
- Many graphic system updates including experimental hardware improvements
  (many different svn rev.)
- Implemented very basic "dedicated" server (many different svn rev.)
- Improved chat system:
    * Added personal messages (use "@username message") (svn:r4186)
    * Added a time string in front of each message (svn:r4253)
- Implemented metaserver lobby for internet game (many different svn rev.)
- Implemented check of free diskspace to avoid segfaults (different svn rev.)
- Added new ware icons. (svn:r4152, svn:r4250, svn:r4471)
- Implemented versioning system to avoid that Widelands loads data of old
  Widelands versions. (svn:r4133)
- Implemented basic "generate random map" feature. (svn:r4113)
- Implemented basic messaging system to inform players of important events.
  (many different svn rev.)
- Improved computer player behaviour (many different svn rev.)
    * Computer player should now be able to build up a working infrastructure
      (including mining, tools and weapons production and soldier training) and
      to attack and defeat their enemies.
    * Users are now able, to select the type of a computer player. The
      available types are: Aggressive, Normal, Defensive and None. First three
      are based upon the improved AI and only behave different in case of
      attacking strength and expansion, while latter does simply nothing.
    * It is now possible to define the computer player type for camapign maps.
- Throw out the bundled version of scons. Scons is widely available by now and
  the bundled version caused more trouble than it was worth: many
  incompatibilities, where a distribution-supplied version would have worked
  (svn:r3929)
- Fix bug #2351257 - wrong game tips are shown. (svn:r3808)
- Some improvements of tribes economy and soldier balance (svn:r3793,
  svn:r3796)
- Added third barbarian campaign (svn:r3790) and improved the already existing
  ones (svn:r3775, svn:r3788)
- Added a new trigger for scenario maps: Player defeated (svn:r3789)
- In the editor save dialog; initialize the name box with the map name and do
  not react (for example by playing a sound) to clicks in the empty area below
  the last file in the listbox (affects all listboxes in the UI). (svn:r3783)
- Fix bug in build13 that the editor save dialog would use the name of the list
  item from the second last (instead of the last) click. (svn:r3781)
- Added an editor tool to set a new origin in the map. This will make it
  possible to get an island properly centered, instead of divided in 4 corners
  when a minimap is generated with an external tool, such as the one used in
  the [map download section](http://wl.widelands.org/maps/). The button that
  enables the tool is in the map options dialog. (svn:r3778)
- Allow longer text for a world's name and author (to avoid having it cut off
  like "The Widelands Development Tea"). (svn:r3777)
- Do not crash when writing an empty file. (svn:r3773)
- Added two new in game and one new menu song. (svn:r3758, svn:r3800)
- Make more configuration options configurable in the options menu. (svn:r2753)
- Fix bugs in the S2 map loader. Trying to load an invalid file could cause
  failed assertions in debug builds and probably other bugs in release builds.
  (svn:r3750)
- Added new loading screens for winterland and for barbarian campaigns.
  (svn:r3748, svn:r3797)
- Allow configuring which information about a building is shown in the
  mapview's building census and statistics displays and the building window
  title. (svn:r3741)
- Added colorized chatmessages. (svn:r3725)
- Added a lobby to the multiplayer launchgame menu. Now users are not
  automatically assigned to players. Users staying in the lobby when the game
  begins will become spectators. (svn:r3702, svn:r3703, svn:r3707, svn:r3709,
  svn:r3710)
- Fix the map Dry Riverbed so that the mountain pass is passable in both
  directions. (svn:r4335)
- Improved the map Plateau so that the players can reach the center even if
  another player is fortified there. This is achieved by allowing large
  buildings at a few more places in the valleys leading from the starting
  positions to the center. Also add some wiese1 (terrain type), which was not
  used at all on this map before. Make some small adjustments to the node
  heights in the small valley just east of player 1's starting position, so
  that the valley becomes more useful. (svn:r3713, svn:r4361, svn:r4362)
- Added two new maps "Twinkling Waves" and "The ancient sun of fire".
  (svn:r3689, svn:r4119)
- Fix bug that the editor toolsize menu was not updated when the toolsize was
  changed with the keyboard shortcuts. (svn:r3675)
- Implement feature request #1792180 - Allow user to change starting-position.
  (svn:r3666, svn:r3667, svn:r3668)
- Editboxes now support UTF8 (unicode) characters, so the players can use their
  locale language in game. (svn:r3662, svn:r4398)
- Improve the output of _widelands --help_. (svn:r3660)
- Add a new terrain type, corresponding to Greenland's bergwiese, to Desert.
  (svn:r3659)
- Workers that search for an object now prefer one of the nearest. Therefore
  they spend less time walking and more time harvesting. (svn:r3658)
- Fix bug that in the military-/trainingsite windows, the name (untranslated)
  of the soldier type was shown instead of the descname (translated).
  (svn:r3645)
- Fix bug that in the trainingsite window, the ware priority buttons were not
  updated. (svn:r3642)
- Fix bug that in the trainingsite window, the column _total level_ was not
  sorted correctly for 2-digit values (10 was sorted between 1 and 2).
  (svn:r3641)
- Fix bug that when the user typed in the editor's map description input
  fields, the world was reparsed on every keystroke, which caused a delay.
  (svn:r3640)
- Fix bug that when the loading of a tribe failed, the error message was
  insufficient. (svn:r3639)
- Fix bug related to land ownership and military influence when a soldier
  arrived to a trainingsite. (svn:r3701)
- Fix bug related to land ownership and military influence when an
  event_building was executed. (svn:r3636, svn:r3637)
- Fix bug that when a \_pc-file was missing for an animation frame, the program
  did not make it clear that it was the \_pc-file that was missing (the user
  was lead to think that it was the main file of the animation frame).
  (svn:r3623)
- Fix bugs in the maps _Mystical Maze_ and _Three Warriors_: update tribe name
  to _atlanteans_. (svn:r3609, svn:r3612)
- Change the Atlantean Weaponsmithy's program Produce Light Trident to consume
  iron (in addition to planks). This makes it necessary to mine iron ore to
  produce soldiers, which makes it more difficult to win against the other
  tribes (who also require iron for making soldiers) (svn:r3718)
- Fix bug in build13 that the Atlantean Labyrinth's program Upgrade Evade 1
  could consume bread and then fail. (svn:r3714)
- Add demand check to _Cloth_ production in _Empire_ _Weaving Mill_.
  (svn:r3604)
- Add a program that produces an axe to the Barbarian Metalworks. (svn:r3717)
- Simplify the stoppability rules of building types. Only productionsites are
  stoppable. A productionsite type is a stoppable if and only if it is not a
  militarysite type. Get rid of the config option to make a building type
  stoppable (many building types had "stopable=yes" in their conf-file). Also
  get rid of the config options to set custom stop/continue icons for each
  building type (this was not used in any of the building types that are
  included in the Widelands releases). It is no longer possible to stop a
  constructionsite so that the finished building will be set to stopped.
  (svn:r3723)
- Get rid of event numbers in event chains. This removes the maximum limit of
  99 events in an !EventChain. It also makes diffs much smaller when an event
  is inserted, because now the following events do not need to be renumbered.
  (svn:r3600)
- For the statistics string of a trainingsite (shown in the mapview near the
  trainingsite when S has been pressed), replace strings like "upgrade_evade_0"
  (untranslated) with strings like "Upgrade evade 0" (translated). (svn:r3595)
- Fix bugs that ware/worker types were identified by their temporary index
  value instead of their permanent name in some places in savegames. The
  temporary index values may not be the same when the game is loaded again,
  while type names should be the same. (svn:r3593, svn:r4343)
- Implement automatic recursive road removal. When a player holds down Ctrl
  when ordering (or confirming, if applicable) the removal of flag or road, do
  a recursive removal. If a road removal command is given with the recursive
  option, all roads between the start and end flags are removed. Then those
  flags that become dead ends are removed recursively. A flag is a dead end if
  it does not have a building and roads to at most 1 other flag. (svn:r3591)
- Make immovable animation times random. (svn:r3635)
- Implement natural reproduction for trees. Instead of just growing up and then
  idling forever, they seed new trees and eventually die. Dead trees disappear
  after a while. Different tree species have different advantages on different
  terrain types. This makes it possible for several tree species to survive by
  occupying different niches. Increase the working radius of
  woodcutters/lumberjacks from 8 to 10. This makes it easier to cover large
  areas with a few of them. This is now recommended to keep an area clear of
  trees. (svn:r3591, svn:r3610, svn:r3735, svn:r3786, svn:r3828)
- Forbid immovable programs to have transform commands that replace an
  immovable with one of the same type. (svn:r3647)
- Get rid of line numbers in immovable programs. (svn:r3591)
- In the worker list window of productionsites; if a worker is missing, show
  "(vacant)" if the request for it is open and "(coming)" if the request is in
  transfer. (svn:r3591)
- Create a few different player initializations and allow choosing one for each
  player when the game is configured. The default initialization is a
  headquarters with the usual set of wares/workers/soldiers, so the default
  behaviour is unchanged. There is another player initialization called
  castle_village that creates a castle (or citadell, depending on tribe) and a
  village around it with a warehouse loaded with some wares/workers/soldiers
  and some basic production and training buildings. (svn:r3629)
- Do not automatically create a headquarters for each player in scenarios. This
  must now be done explicitly with events. Change the existing scenarios
  accordingly (and use new headquarter graphics in some of them). (svn:r3591,
  svn:r3617, svn:r3737, svn:r4249, svn:r4299)
- Implemented logic for finding a suitable location for a building that will be
  created with an event. (svn:r3629)
- When a warehouse is created through an event, allow configuring exactly how
  many of each type of ware, worker and soldier that should be created with the
  warehouse. (svn:r3591)
- When a productionsite is created through an event, allow configuring exactly
  which of the wares and workers that should be created with the
  productionsite. (svn:r3591, svn:r3630)
- When a military-/trainingsite is created through an event, allow configuring
  exactly how many soldiers at each combination of strength levels that should
  be created with the site. (svn:r3628, svn:r3629)
- The builder does no longer enter the building and see the surroundings for a
  moment when he has completed the construction. Instead he leaves directly.
  (svn:r3590)
- Added new portrait pictures for the campaign maps (svn:r3581, svn:r3632)
- Allow multiple AI implementations (svn:r3574)
- Implement a debug console and add a "switchplayer" command (svn:r3573,
  svn:r4370, svn:r4371)
- Fix bug that the back buttons in the campaign selection UI had the wrong
  background. (svn:r3619)
- Improvements of full screen menu UI (svn:r3579, svn:r3581)
   * Make fullscreen menus dynamic resizable. Now the menus use the same
     resolution as the whole game. Still the resolution must be saved in the
     config, so it is not yet possible to resize via mouse.
   * Clean up menu design, make some menus more straight and intuitive and
     follow the same alignment in similar menus.
   * Add note to intro screen, so players are not confused anymore, whether
     Widelands is still loading.
   * Introduce config option and commandline parameter "ui_font". This option
     allows the user, to use a different font in the fullscreen menus, which
     can be quite important if the resolution is very low and the serif font is
     nearly unreadable. Besides a path to a TTF file relative to
     <widelands-data>/fonts/ the values "sans" and "serif" are accepted. If an
     invalid parameter was given Widelands falls back to UI_FONT_NAME.
- Made the minimap remember its display options during the session (svn:r3572)
- Implemented generation of browsable HTML from game data. (svn:r3548)
- Made it possible to define a default target quantity for a ware type and set
  target quantities in the game. (svn:r3543)
- Made Ctrl+S bring up the save game dialog in both gameplay and replay. Added
  save button in replay watcher. (svn:r3542)
- Fixed Trigger_Time (and replaced Trigger_Null with it). Introduced
  Event_Set_Timer. (svn:r3541, svn:r4485)

### Build 13
- Count casualties/kills, military/civilian buildings lost/defeated and present
  them in the general statistics menu (except for civilian buildings defeated,
  which is omitted from the user interface) (svn:r3395, svn:r3407).
- Improved map options menu (svn:r3328).
- Improved progresswindow use and added new loading screens (svn:r3249,
  svn:r3253, svn:r3275, svn:r3315, svn:r3316).
- Added menu for editor to the mainmenu (svn:r3248).
- Improved save game dialog (svn:r3185, svn:r3189).
- Improved mapselect and launchgame menu (svn:r3243, svn:r3246, svn:r3247,
  svn:r3283, svn:r3290).
- Improved ingame UI (svn:r3224).
- Implemented "/me" command for multiplayer chat (svn:r3223).
- Improved multiplayermenu (svn:r3218, svn:r3260, svn:r3261, svn:r3288,
  svn:r3289).
- Improved optionsmenu and added possibility to set autosave interval
  (svn:r3215).
- Implemented option for maximum FPS to reduce CPU-usage (svn:r3210, svn:r3213,
  svn:r3214, svn:r3215, svn:r3220).
- Improved editor new map dialog (svn:r3172, svn:r3331).
- Make automatic roadbuilding mode after creation of non-connected flag
  optional (svn:r3177).
- Improved production program handling (svn:r3373, svn:r3384):
   * Eliminate the need for line numbers in the programs.
   * Fix bug that the consume command required that all wares in a
     consume-group must be of the same type. For example the command "2=consume
     smoked_fish,smoked_meat 2" required 2 smoked_fish or 2 smoked_meat. Now it
     will also work if there is only one of each.
   * Change the syntax of a consume-group to ware1[,ware2[,...]][:quantitiy]
     (for example "smoked_fish,smoked_meat:2").
   * Extend the consume command to take any number of consume-groups (for
     example smoked_fish,smoked_meat:2 bread:2"). This means that unless all
     consume-groups can be satisfied, nothing is consumed when the command
     fails. This will fix many bugs in the game data where programs had for
     example "2=consume smoked_fish,smoked_meat 2" and "3=consume bread 2". If
     there was not 2 bread, it would consume 2 smoked_fish or 2 smoked_meat and
     then fail.
   * Get rid of the command check. It was only a work-around for the previously
     deficient command consume (and some programs forgot to use it).
   * Implement the new command return. It can return from a program. There are
     3 different return values; Failed, Completed and Skipped. Only programs
     returning Failed and Completed will affect statistics. A program that
     reaches the end will be considered to have implicitly returned Completed.
     The return command can optionally take a condition. Currently only two
     conditions are supported; "economy needs ware_type" and "workers need
     experience". The former will allow a program to have a command
     "return=skipped unless economy needs marblecolumn". It will prevent Game
     Over as a result of a production deadlock on marble when a user forgets to
     turn off a stonemason for a while. This fixes the huge problem with
     production deadlocks that hit every new player in their first games and
     every experienced player once in a while. The condition makes a query to
     the economy, which now simply checks if there is no warehouse supplies the
     ware type. This can of course be made much smarter later. The latter is
     used in the barbarian micro-brewery to let it practice making beer until
     the brewer has become a master_brewer even if the economy does not need
     any beer.
   * Extend the produce command to take any number of ware types with
     quantities.
   * Fix the call command to validate that the called program exists. This
     requires changing declaration order in some data files (for example if
     "work" calls "seed", "program=seed" must come before "program=work" in the
     "global" section of the productionsite definition. (However the definition
     order of the programs does not matter.) This fixes the bug that a call
     command may fail at run-time because the called program does not exist.
   * Extend the call command with an optional error handling specification
     (call=<program_name> [on failure {ignore|repeat|fail}]). It will make it
     possible to ignore a failure of a called program and continue the calling
     program, or repeat the failed program until it succeeds.
   * Extend the sleep and animate commands. If no duration is given as the last
     parameter, the return value from a previous action is used for duration.
     This makes it possible to for example let the mining command calculate how
     long the following sleep/animation should last, depending on ore
     concentration and mining depth.
   * Get rid of the set command and the associated catch and nostats flags.
   * Fix the mine command to parse and validate its parameters at parse-time
     instead of at run-time. This fixes the bug that the game engine could fail
     with the message "Should mine resource <resource_type>, which does not
     exist in world. Tribe is not compatible with world!!" at run-time the
     first time a mining command is executed.
   * Fix most other commands that had insufficient validation or did parsing at
     run-time (for example the consume command reparsed its wares at each
     execution).
   * Optimize the parsing by eliminating needless string copying.
- Rename the building property "enhance_to" to "enhancement" and validate that
  the given building type exists (svn:r3373).
- Improved editor handling of bobs and animals, so they can not be placed on
  invalid locations (svn:r3319, svn:r3321).
- Implemented loading of savegames in multi player (svn:r3266, svn:r3270,
  svn:r3271)
- Only allow attacking seen buildings (svn:r3173).
- Improved computer player behaviour (svn:r3209).
- Update and cleanup of tribes economies (svn:r3202, svn:r3203, svn:r3204,
  svn:r3205, svn:r3206, svn:r3207, svn:r3211, svn:r3237, svn:r3239, svn:r3241,
  svn:r3257, svn:r3258, svn:r3269, svn:r3272, svn:r3294, svn:r3307).
- Introduced automatic update of Campaign-list via campaign-menu (svn:r3197,
  svn:r3198).
- Added a new in game song
- Added global objects usable in every world (svn:r3308, svn:r3310, svn:r3311).
- Added 12 new maps (9 from map contest) (svn:r3226, svn:r3298, svn:r3305).
- Added atlantean building graphics (svn:r3278, svn:r3295, svn:r3300,
  svn:r3309, and many more).
- Added a lot of new sounds and integrated them in the game (svn:r3231,
  svn:r3232, svn:r3415, svn:r3419, svn:r3439).
- Rework of campaign missions (svn:r3228, svn:r3233, svn:r3236, svn:r3242).
- Fix bugs in parsing of building types's buildcosts and inputs. Check that the
  ware types exist and are not duplicated and that the quantities are within
  range (svn:r3373).
- Fix bug in parsing of productionsite types' outputs. Check that the ware
  types exist and are not duplicated (svn:r3373).
- Fix bugs in parsing of productionsite types', critter_bob types' and worker
  types' programs. If a program was declared twice, it was parsed twice and the
  memory used to store the first instance was leaked (svn:r3373).
- Fixed bugs with drop-soldier commands: If such a command was given and then
  the game was saved before the command was executed (because the game was
  paused), the command was saved incorrectly (svn:r3451, svn:r3456). And even
  if the savegame would have had such a command correctly saved, the loading
  code would not have recognized it (svn:r3456).
- Removed the trainingsite options window. The "Make heros" button was
  suspected of being able to cause desync in network games (svn:r3452).
- Fixed bugs that attack, change-soldier-capacity and set-ware-priority
  commands were not recognized when encountered in savegames (svn:r3454,
  svn:r3456, svn:r3455).
- Fixed bug that set-ware-priority commands were saved as enhance-building
  commands (svn:r3455).
- Change game rule: Forbid upgrading any building to any type of building. Only
  allow upgrading to one of the defined enhancements. This is the behaviour
  that was intended and that the user interface obeys. Now also the game logic
  enforces it. This prevents users from circumventing the user interface and do
  arbitrary building upgrades, which other players may consider cheating in a
  network game (svn:r3457).
- Fix program crash (or worse) when a worker type was declared to have an
  ingredient that had not been defined (svn:r3459).
- Forbid declaring that a building can be enhanced to its own type or the
  special type constructionsite (svn:r3460, svn:r3461).
- Do not let the constructionsite crash the game if a building type did not
  define a build animation. Use the idle animation instead (svn:r3462).
- Do not crash because of division by 0 when building a building without
  buildcost (svn:r3462).
- When building a building without buildcost, complete it immediately instead
  of never (svn:r3462).
- Check for mine and size mismatch when parsing building enhancement
  definitions. This prevents crashes at run-time (svn:r3463).
- Fixed bug #1792379 - little trees set with editor do not grow (svn:r3317).
- Fixed bug #1913902 - collosseum now trains evade 0 and 1 (svn:r3303).
- Fixed bug that upgraded worker were used in buildings instead of training new
  simple ones (svn:r3304).
- Fixed crossplatform network bug (win32 path on unix) (svn:r3293, svn:r3427,
  svn:r3429).
- Fixed disk_filesystem handling on win32(svn:r3284, svn:r3285, svn:r3286,
  svn:r3287, svn:r3291).
- Fixed strange, unwanted behaviour of multilined editboxes (svn:r3281,
  svn:r3282).
- Fixed loading of settlers 2 maps in widelands (svn:r3234, svn:r3235,
  svn:r3238, svn:r3250).
- Fixed bug that caused segmentation fault when executing./widelands
  --editor=nonexistent_file (svn:r3335).
- Fixed bug that caused segmentation fault when executing./widelands
  --scenario=nonexistent_file (svn:r3336).
- Fixed bug that caused invalid use of uninitialized memory when an animation
  configuration defined playercolor=true but a mask file was missing
  (svn:r3347).
- Fixed bug #1968196 - Scenario-maps are not loaded as one (svn:r3227).
- Fixed bug #1900477 - Objectives description are not translated and objective
  names are not included in PO templates (svn:r3225, svn:r3229).
- Fixed hotspots of animals (svn:r3170).
- Fixed editor height tool dialogs (svn:r3171).
- Fixed language-settings-menu for Linux - now Widelands sets
  system-language-variable correctly (svn:r3193, svn:r3252, svn:r3262).
- Fixed bug that prevented releasing the last soldier from a trainingsite
  (svn:r3179).
- Fixed memory access errors in the game logic, causing segmentation fault or
  any kind of strange undefined behaviour (svn:r3184, svn:r3365).
- Fixed bug that the game would abort if an attacking soldier could not find a
  path to the target (svn:r3382).
- Fixed memory access error in save game dialog (svn:r3185).
- Fixed many memory access errors when trying to read missing sections in
  configuration files (svn:r3195).
- Fixed bug that the computer player did not check if a planned large building
  would be completely inside his borders (svn:r3191).
- Fixed bugs that the empire wine bush and barbarian flax and reed lived
  forever, blocking the map (svn:r3190, svn:r3527).
- Fixed bug that it was possible to cheat when destroying an enhanceable
  building by first ordering and upgrade and then immediately ordering the
  destruction of the enhancement-constructionsite. This avoided the burning
  phase, which made the space available immediately. (svn:r3513)
- Fixed bug that replay was stopped before all commands had been executed.
  (svn:r3539)


### Build 12
- New feature: Additional scenario event types and trigger types.
- New feature: Flags are automatically placed when holding down Ctrl while
  building a road.
- New feature: Load maps directly into the editor from the command line
  (widelands --editor=<filename>).
- New feature: Navigation in edit boxes.
- New feature: Multiplayer games.
- New and greatly improved animations for a number of workers.
- New animals and new animations for existing animals.
- New singleplayer/multiplayer map.
- New tribe Atlantids.
- Improved the usability of scrollbars, listselects and tables.
- Improvements of Campaign UI (show only revealed campaigns/scenarios).
- Improvements of all single-/multiplayer maps (rebalancing resources).
- Improved the building statistics menu.
- Improved the scenarios to make use of new features.
- Improved the performance of terrain rendering.
- Improved usability of roadbuilding.
- Improved the handling of player colours.
- Improved recovery from bugs during gameplay.
- Improved the battle system.
- Fixed bugs: Several invalid memory accesses, which may have caused random
  bugs, such as [#1508297 (Needed images sometimes not saved with
  game)](http://sourceforge.net/tracker/index.php?func=detail&aid=1508297&group_id=40163&atid=427221).
- Fixed bug: Workers that become fugitives have a higher chance of finding back
  to a warehouse. A flag connected to a warehouse must be close to the worker.
- Fixed bug that the objectives menu was not updated when objectives were
  fulfilled during the game.
- Fixed bug that workers would enter a building before arriving at it (entering
  it when passing the flag in front of the building). This caused the worker to
  start seeing from the building too early.
- Fixed network support for direct IP and LAN games.
- Fixed many gamelogic bugs.
- Removed support for GGZ. Please use the forums and IRC channel to meet for
  multiplayer games.
- Many other bugfixes, optimizations and cleanups.

### Build 11
- New feature: Game Tips during loading
- New feature: Progress message windows (Loading-screens)
- New feature: Fog of war
- New feature: Autosave (and emergency-save)
- New feature: Visible Range for bobs and buildings
- New feature: Replay-function
- New feature: volume-sliders for sound and music
- New animations for animals
- New animations for bobs (few trees are falling after they are choped)
- Improvements of the transportationsystem (f.e. ware priority-buttons)
- Improvements of the S2-Map-importation-system.
- Improvements of Multiplayercode.
- Improvements of Campaign UI
- Improvement of "growing tree patch" (seperation of different steps)
- Improvement of single-line-edit-box handling (buttons are not locked anymore)
- Improvement of Ware-image visualisation program.
- Added 2 new multiplayer maps
- Fix of bug 1633431 (Attacking headquarters crashes game.)
- Fix of bug 1451851 (Upgrade building while delievering to/from cause
  crash/hang)
- Fix of bug 1690070 (ware: can not move from building A to B)
- Many other bugfixes


### Build 10
- Addition of new tribe "The Empire"
- Tribe "Barbarians" was completely overhauled
- New blender graphics for the Barbarians and the Empire by bithunter32
- New blender graphics for the Empire by !AlexiaDeath
- Addition of new worlds (Blackland, winterland and desert)
- Addition of few new maps
- Addition of two new Empire-campaign-maps
- Addition of three new ingame music-tracks
- A lot of localization-bugs were fixed and new strings for translation were added.
- Widelands now supports 14 languages (cz_CZ, de_DE, en_EN, es_ES, fi_FI,
  fr_FR, gl_ES, he_HE, hu_HU, nl_NL, pl_PL, ru_RU, sk_SK, sv_SE)
- New feature: Mouse-over-hover-help
- New feature: Tribe ware encyclopedia
- Mousewheel support integrated (textarea)
- Now using new fonts (!FreeSans and !FreeSerif) licensed under GPL
- Battlecode was reworked
- Menu-resolution set to 800x600 (before 640x480) and added new splash
- Work on ingame window-system
- Richtext-handler was overhauled
- A lot of menu texts and alignments were fixed
- A lot of new button-, icon-, background- and campaign-graphics added.
- A lot of code-cleanup
- Bug fixes, bug fixes, bug fixes


### Build 9half
- Updated Campaign Missions
- Added proper localization support (language selectable in options menu)
- Font renderer now renders multiple newlines correctly and in richtext accepts
  <br> as newline
- added localization patch by Josef + beginning of localization
- f now triggers fullscreen ingame
- added new maps from winterwind
- implemented new trigger system. This invalidates every scenario, campaign and
  map.
- save now changes into zip files, added option nozip for debugging reasons
- save changed to save into directory
- added trigger conditionals
- Patch to fix graphic problems:
   * Alpha instead of clrkey
   * Fixed all bugs with !MacOSx
   * Caching landscape renderer speeds things up
- Sound patch + Music
- RTF Renderer
- show workarea preview
- new font renderer


### Build 9
- Chat for multiplayer
- Global Stock, Menu structure reworked
- General statistics menu
- Building statistics menu
- Ware Statistics Menu
- Minor changes in barbarians conf files (Descnames mainly)
- added road textures
- Initial Version of game server. Only chatting.
- First version of barbarians tribe comitted
- Added training site/military patch by Raul Ferriz
- fixed "Worker Type 11 not found" bug
- new Tree Graphics from Wolfgang Weidner
- Added patch from Florian Falkner
   * new Option Dialog UIListselect can have now a selection-indicator
     !WatchWindow
   * functionality is user selectable
- Windows can be minimized (middle mouse or Ctrl+left mouse)
- fixed crash when using 32-bit fullscreen mode under win32


### Build 8
- some UI ergonomics (new mapselect dialog,
  double click function in listselects)
- resources and default resources support
- loading/saving of maps
- preliminary TT-Font support
- enhancing buildings support
- build animation support
- editor events/trigger
- editor player menu
- editor bob tool


### Build 7
- many new buildings
- improved in-game graphics
- improved in-game UI
- movement speed depends on slope of terrain
- improved watch window functionality
- improved the transport system
- added a 32 bit software renderer
- improved rendering quality
- added infrastructure for real-time in-game debugging and inspection
- various code cleanups and bug fixes


### Build 6
- graphics reworked
- added functionality for the first few buildings
- reworked transport code
- added multiselect option for editor's set texture tool


### Build 5
- added Immovable Tool in editor
- added Map_Loader support
- added support for multifield-fieldsels (for editor and to select areas)
- added height tools in the editor
- added item ware code
- added ware transportation (carriers stay on roads and can carry wares)
- construction sites are implemented
- added support for more (and most importantly: compressed) graphics formats


### Build 4
- added Warehouse options window
- added ware requests


### Build 3
- added !DirAnimations for convenience
- added Economy code
- added record/playback code
- added wares code
- added worker code
- use different background images for different menus


### Build 2
- options handling redesigned
- introduced System
- added keyboard input
- build symbols react to objects now (can not build next to stones etc...)
- only use 8 different types of trees (like Settlers 2)
- unique windows now remember their position
- improved fieldaction mouse placement for fast click-through
- new structure for tribe data
- new terrain textures
- added "fps" key to animations
- renderer uses player colors
- added flags
- added road building
- split of moving and non-moving objects in hierarchy


### Build 1
* First release

